import java.util.List;

import ru.ifmo.testlib.*;
import ru.ifmo.testlib.Outcome.Type;

public class Check implements Checker {
    final double eps = 1e-6;
    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        try {
            String cAns = ouf.nextToken();
            String jAns = ans.nextToken();
            if (jAns.equals("inf")) {
            	if (!jAns.equals(cAns)) {
            	    return new Outcome(Type.WA, String.format("Wrong answer: Expected %s, found %s", jAns, cAns));
            	}
            }else {
            	if (Math.abs(Double.parseDouble(cAns) - Double.parseDouble(jAns)) >= eps) {
            	    return new Outcome(Type.WA, String.format("Wrong answer: Expected %s, found %s",jAns, cAns));
            	}      
            }
            if (!ouf.isEoF())
                ouf.nextLine();
            if (!ans.isEoF())
                ans.nextLine();
        } catch(Exception e) {
            return new Outcome(Type.PE, "Few tokens");
        }
        return new Outcome(Type.OK, "No differences");
    }
}
