import java.io.*;
import java.util.*;

public class TestGen {

    static PrintWriter out;
    static Random rnd = new Random(0);
    static int tNumber = 1;
    static PrintWriter testDescr;
    static int sb = 0;


    static void printTest(int n, int k, int v1, int v2, int s, int[] arr, int[] dst, String comment) throws IOException {
        System.out.println(String.format("Generating test %d", tNumber));
        if (tNumber < 10)
            out = new PrintWriter("../tests/0" + tNumber);
        else
            out = new PrintWriter("../tests/" + tNumber);
        out.println(n + " " + k);
        out.println(v1 + " " + v2);
        out.println(s);
        for (int i = 0; i < n; i++)
            out.println(dst[i] + " " + arr[i]);        
        out.close();
        testDescr.println("../tests/" + ((tNumber > 9) ? tNumber : ("0" + tNumber)) + ", folder=tests, subtask=subtask" + sb + ", points=0, comment=\"" + comment + "\"");
        tNumber++;        
    }
    
    static void genSample() throws FileNotFoundException {
        out = new PrintWriter("../preliminary/01");        
        out.println("6 2");
        out.println("1 2");
        out.println("3");
        out.println("0 1");
        out.println("5 2");
        out.println("7 3");
        out.println("10 4");
        out.println("11 5");
        out.println("12 6");
        out.close();                
        testDescr.println("../preliminary/01, folder=preliminary, subtask=subtask0, points=0, comment=\"sample 1\"");

        out = new PrintWriter("../preliminary/02");        
        out.println("1 1");
        out.println("2 1");
        out.println("1");
        out.println("1 1");
        out.close();                
        testDescr.println("../preliminary/02, folder=preliminary, subtask=subtask0, points=0, comment=\"sample 2\"");
    }
    
    static int randFromTo(int l, int r) {
        return rnd.nextInt(r - l + 1) + l;      
    }

    static int[] genArrayTrap(int n, int mn, int mx) {
        int[] ans = new int[n];
        for (int i = 0; i < n; i++) 
            ans[i] = randFromTo(mn, mx);
        return ans;       
    }
    
    static int[] genArrayDst(int n, int mnl,int mxl) {
        int[] ans = new int[n];
        ans[0] = 0;
        for (int i = 1; i < n; i++) 
            ans[i] = randFromTo(ans[i - 1] + 1, ans[i - 1] + randFromTo(mnl, mxl) + 1);
        return ans;       
    }

    private static int rand() {
        return rnd.nextInt(100000);
    }

    public static void main(String[] args) throws IOException {
        new File("../preliminary").mkdir();
        new File("../tests").mkdir();        
        testDescr = new PrintWriter("../tests.desc");
        genSample();
        {
            sb = 1;
            {
                int n = 20;
                int v2 = rand() % 3 + 1;
                int v1 = v2;
                int s = 0;
                int k = rand() % 7;
                int[] arr = genArrayTrap(n, 1, 3);
                int[] dst = genArrayDst(n, 1, 10);
                printTest(n, k, v1, v2, s, arr, dst, "small test: n = " + n);
            
            } 

			{
                int n = 20;
                int v2 = 10;
                int v1 = 1;
                int s = 10;
                int k = 10;
                int[] arr = genArrayTrap(n, 1, 3);
                int[] dst = genArrayDst(n, 100, 10000);
                printTest(n, k, v1, v2, s, arr, dst, "small test: n = " + n);
            
            } 

            for (int i = 0; i < 5; ++i) {
                int n = 20;
                int v2 = rand() % 3 + 1;
                int v1 = rand() % v2 + 1;
                int s = rand() % 5;
                int k = rand() % 7;
                int[] arr = genArrayTrap(n, 1, 3);
                int[] dst = genArrayDst(n, 1, 10);
                printTest(n, k, v1, v2, s, arr, dst, "small test: n = " + n);
            }
            
            for (int i = 0; i < 5; ++i) {
                int n = 100;
                int v2 = rand() % 15 + 1;
                int v1 = rand() % v2 + 1;
                int s = rand() % 10;
                int k = rand() % (10*i + 1);
                int[] arr = genArrayTrap(n, 1, 10);
                int[] dst = genArrayDst(n, 1, i*5+1);
                printTest(n, k, v1, v2, s, arr, dst, "small test: n = " + n);
            }

            for (int i = 0; i < 5; ++i) {
                int n = 1000;
                int v2 = rand() % 50 + 1;
                int v1 = rand() % v2 + 1;
                int s = rand() % 50;
                int k = rand() % (100*i + 1);
                int[] arr = genArrayTrap(n, 1, 50);
                int[] dst = genArrayDst(n, 10, 50);
                printTest(n, k, v1, v2, s, arr, dst, "hand test: n = " + n);
            }
            {
                int n = 1000;
                int v2 = rand() % 50 + 2;
                int v1 = rand() % v2 + 1;
                int s = rand() % 50;
                int k = 900;
                int[] arr = new int[n];
                int[] dst = new int[n];
                int l = 100;
                for (int i = 0; i < n; i++)
                    arr[i] = l * v2 - l * v1;
                int last = 0;
                for (int i = 0; i < n; i++, last += l)
                    dst[i] = last;
                printTest(n, k, v1, v2, s, arr, dst, "hand test: n = " + n);
            }
            for (int it = 0; it < 3; it++) {
                int n = 1000;
                int v2 = rand() % 100 + 1;
                int v1 = v2 - 1;
                int s = rand() % 100;
                int k = 900;
                int[] arr = new int[n];
                int[] dst = new int[n];
                int l = 1;
                for (int i = 0; i < n; i++)
                    arr[i] = 1000;
                int last = 0;
                for (int i = 0; i < n; i++, last += l)
                    dst[i] = last;
                printTest(n, k, v1, v2, s, arr, dst, "middle test: n = " + n);
            }

            {
                int n = 1000;
                int v2 = rand() % 50 + 1;
                int v1 = v2;
                int s = rand() % 50;
                int k = 900;
                int[] arr = new int[n];
                int[] dst = new int[n];
                int l = 100;
                for (int i = 0; i < n; i++)
                    arr[i] = 1;
                int last = 0;
                for (int i = 0; i < n; i++, last += l)
                    dst[i] = last;
                printTest(n, k, v1, v2, s, arr, dst, "hand test: n = " + n);
            }
            {
                int n = 1000;
                int v2 = rand() % 50 + 1;
                int v1 = v2 + 1;
                int s = rand() % 50;
                int k = 900;
                int[] arr = new int[n];
                int[] dst = new int[n];
                int l = 100;
                for (int i = 0; i < n; i++)
                    arr[i] = 1;
                int last = 0;
                for (int i = 0; i < n; i++, last += l)
                    dst[i] = last;
                printTest(n, k, v1, v2, s, arr, dst, "hand test: n = " + n);
            }
            testDescr.println("comment_subtask1=\"n &lt;= 1000, k &lt;= 1000\"\nbonus_subtask1=40");
        }
        {
            sb = 2;
            for (int i = 0; i < 5; ++i) {
                int n = 100000;
                int v2 = rand() % 1000 + 1;
                int v1 = rand() % v2 + 1;
                int s = rand() % 1000;
                int k = rand() % 10000;
                int[] arr = genArrayTrap(n, 100, 1000);
                int[] dst = genArrayDst(n, 1, 10);
                printTest(n, k, v1, v2, s, arr, dst, "big test: n = " + n);
            }
            
            for (int i = 0; i < 5; ++i) {
                int n = 100000;
                int v2 = rand() % 1000 + 1;
                int v1 = rand() % v2 + 1;
                int s = rand() % 1000;
                int k = rand() % (10000*i + 1);
                int[] arr = genArrayTrap(n, 100, 1000);
                int[] dst = genArrayDst(n, 100, (i+1)*100+1);
                printTest(n, k, v1, v2, s, arr, dst, "big test: n = " + n);
            }

            for (int i = 0; i < 5; ++i) {
                int n = 100000;
                int v2 = rand() % 50 + 1;
                int v1 = rand() % v2 + 1;
                int s = rand() % 500;
                int k = 99000;
                int[] arr = genArrayTrap(n, 100, 1000);
                int[] dst = genArrayDst(n, 500, 1000);
                printTest(n, k, v1, v2, s, arr, dst, "big test: n = " + n);
            }
            {
                int n = 100000;
                int v2 = rand() % 50 + 3;
                int v1 = rand() % v2 + 1;
                int s = rand() % 50;
                int k = 90000;
                int[] arr = new int[n];
                int[] dst = new int[n];
                
                int l = 100;
                for (int i = 0; i < n; i++)
                    arr[i] = Math.min(1000, l * v2 - l * v1);
                int last = 0;
                for (int i = 0; i < n; i++, last += l)
                    dst[i] = last;
                printTest(n, k, v1, v2, s, arr, dst, "big test: n = " + n);
            }
            for (int it = 0; it < 5; it++) {
                int n = 100000;
                int v2 = rand() % 1000 + 1;
                int v1 = v2 - 1;
                int s = rand() % 100;
                int k = 90000;
                int[] arr = new int[n];
                int[] dst = new int[n];
                
                int l = 1;
                for (int i = 0; i < n; i++)
                    arr[i] = 1000;
                int last = 0;
                for (int i = 0; i < n; i++, last += l)
                    dst[i] = last;
                printTest(n, k, v1, v2, s, arr, dst, "middle test: n = " + n);
            }

            {
                int n = 100000;
                int v2 = rand() % 1000 + 1;
                int v1 = v2;
                int s = rand() % 500;
                int k = 90000;
                int[] arr = new int[n];
                int[] dst = new int[n];
                
                int l = 100;
                for (int i = 0; i < n; i++)
                    arr[i] = 1;
                int last = 0;
                for (int i = 0; i < n; i++, last += l)
                    dst[i] = last;
                printTest(n, k, v1, v2, s, arr, dst, "hand test: n = " + n);
            }
            testDescr.println("comment_subtask2=\"n &lt;= 100000, k &lt;= 100000\"\nbonus_subtask2=60");
        }
        testDescr.close();
    }                 
    
}
